Loading...
Searching...
No Matches
rfnoc_ddc.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2019 Ettus Research, a National Instruments Brand.
* Copyright 2020 Free Software Foundation, Inc.
*
* SPDX-License-Identifier: GPL-3.0-or-later
*/
#ifndef INCLUDED_GR_UHD_RFNOC_DDC_H
#define INCLUDED_GR_UHD_RFNOC_DDC_H
#include <gnuradio/uhd/api.h>
#include <gnuradio/uhd/rfnoc_block.h>
namespace gr {
namespace uhd {
/*! RFNoC Digital Downconverter Block
*
* \ingroup uhd_blk
*/
class GR_UHD_API rfnoc_ddc : virtual public rfnoc_block
{
public:
typedef std::shared_ptr<rfnoc_ddc> sptr;
/*!
* \param graph Reference to the rfnoc_graph object this block is attached to
* \param block_args Additional block arguments
* \param device_select Device Selection
* \param instance Instance Selection
*/
static sptr make(rfnoc_graph::sptr graph,
const ::uhd::device_addr_t& block_args,
const int device_select,
const int instance);
/*! Set the DDS frequency of the DDC
*
* \param freq Frequency Shift (Hz)
* \param chan Channel Index
* \param time Command Time for the frequency shift
*/
virtual double set_freq(const double freq,
const size_t chan,
const ::uhd::time_spec_t time = ::uhd::time_spec_t::ASAP) = 0;
/*! Manually configure output rate
*
* When the DDC block is connected to an RX streamer block, then this will
* help with the property propagation.
*
* \param rate Sampling Rate (Hz)
* \param chan Channel Index
*/
virtual double set_output_rate(const double rate, const size_t chan) = 0;
};
} // namespace uhd
} // namespace gr
#endif /* INCLUDED_GR_UHD_RFNOC_DDC_H */
gr::uhd::rfnoc_block::rfnoc_block
rfnoc_block(::uhd::rfnoc::noc_block_base::sptr block_ref)
gr::uhd::rfnoc_ddc
Definition rfnoc_ddc.h:23
gr::uhd::rfnoc_ddc::set_freq
virtual double set_freq(const double freq, const size_t chan, const ::uhd::time_spec_t time=::uhd::time_spec_t::ASAP)=0
gr::uhd::rfnoc_ddc::make
static sptr make(rfnoc_graph::sptr graph, const ::uhd::device_addr_t &block_args, const int device_select, const int instance)
gr::uhd::rfnoc_ddc::set_output_rate
virtual double set_output_rate(const double rate, const size_t chan)=0
gr::uhd::rfnoc_ddc::sptr
std::shared_ptr< rfnoc_ddc > sptr
Definition rfnoc_ddc.h:25
gr::uhd::rfnoc_graph::sptr
std::shared_ptr< rfnoc_graph > sptr
Definition rfnoc_graph.h:32
api.h
GR_UHD_API
#define GR_UHD_API
Definition gr-uhd/include/gnuradio/uhd/api.h:18
gr::uhd
Definition amsg_source.h:19
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
rfnoc_block.h